#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#==================================================================================
#  Copyright:
#            
#      Copyright (C) 2010 Konstas Marmatakis <marmako@gmail.com>
#
#   License:
#  
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License version 2 as
#      published by the Free Software Foundation.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this package; if not, write to the Free Software
#      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#================================================================================== 

from tkinter import ttk, messagebox, Listbox, Toplevel, IntVar, StringVar,\
    DoubleVar
from tkinter.constants import END, W, E, VERTICAL, S, DISABLED, N
import sqlite3
from libs.lib import agora_int, fillcombo


vasi ='data/apodixis.db'

def tropo_apodixis():
    root =Toplevel()
    root.title('Περιήγηση Αποδείξεων')

    
    def exit():
        #
        "dummy function"
        pass
    
    
    root.protocol("WM_DELETE_WINDOW", exit)
    
    aa=IntVar()
    afm = StringVar()
    ar_apod = StringVar()
    hmerominia = StringVar()
    typosagoras = StringVar()
    gposo = DoubleVar()
    epixirisi=StringVar()

    
    def updateme(*dedomena):
           
        query="UPDATE apodixis SET arithmos_apod=?, afm = ?, typos_agoras= ?, ddate =?, poso =? WHERE aa =?"
        
        syndesi = sqlite3.connect(vasi)
        curr = syndesi.cursor()
        typos=agora_int(vasi, str(typosagoras.get()))
        curr.execute(query , ( str(ar_apod.get()), str(afm.get()), typos, str(hmerominia.get()), str(gposo.get()), str(aa.get())))
        syndesi.commit()
        syndesi.close()
        minima ='Τα στοιχεία της απόδειξης με ΑΑ: {0} καταχωρήθηκε'.format(str(aa.get()))    
        messagebox.showinfo("Έγινε Ενημέρωση", minima)
#            kataxorisi.configure(state= NORMAL)
#            tkafm.configure(state=NORMAL) 

    def clear_fields():
            tkafm.delete(0, END)
            tkgar_apod.delete(0, END)
            tkhmeromhnia.delete(0, END)
            tktyposagoras.delete(0, END)
            tkposo.delete(0, END)
            tkaa.delete(0, END)
            tkafm.focus()
            
    def del_record(db,idx):
        if messagebox.askyesno('Διαγραφή Απόδειξης', 'Θέλετε να διαγράψετε την απόδειξη με Α/Α: {0}'.format(aa.get()))==True:
            query= "DELETE FROM apodixis WHERE aa="+ str(aa.get())
            syndesi= sqlite3.connect(db)
            curs= syndesi.cursor()
            curs.execute(query)
            syndesi.commit()
            syndesi.close()
            l.delete(idx)
            clear_fields()
            
                    
    def set_combo(id, dbasename=vasi):
        syndesi_t = sqlite3.connect(dbasename)
        curr = syndesi_t.cursor()
        curr.execute("SELECT perigrafi FROM eidos_agoras WHERE eidos_id=" +str(id))
        rec= curr.fetchall()
        for row in rec:
            return row[0]
        syndesi_t.commit()
        syndesi_t.close()

    def grabrecs(databasename, idx):
        query= "SELECT * FROM apodixis WHERE aa="+ str(idx)
        syndesi_tt= sqlite3.connect(databasename)
        curs= syndesi_tt.cursor()
        curs.execute(query)
        recs= curs.fetchall()
        syndesi_tt.close()
        return recs

    kentrikoframe = ttk.Frame(root)
    kentrikoframe.grid(column=0, row=0, sticky=(N, W, S, E))
    kentrikoframe.columnconfigure(0, weight=1)
    kentrikoframe.rowconfigure(0, weight =1)
    
   
   

# Δημιουργία του Listbox
    query= "SELECT aa FROM apodixis ORDER BY aa"
    syndesi_tt= sqlite3.connect(vasi)
    curs= syndesi_tt.cursor()
    curs.execute(query)
    recs= curs.fetchall()
    
    def setme(event):
        global records
        index=l.curselection()
        txt.set('Απόδειξη Νο: '+ str(l.get(index)))
        records=grabrecs(vasi, l.get(index))
        aa.set(records[0][6])
        afm.set(records[0][1])
        ar_apod.set(records[0][0])
        hmerominia.set(records[0][4])
        gposo.set(records[0][5])
        typosagoras.set(set_combo(records[0][3]))
    
    l=Listbox(kentrikoframe, width=10, height=10)
    l.grid(column=1, row=1, rowspan=6, sticky=(N,S,W,E))
    s=ttk.Scrollbar(kentrikoframe, orient=VERTICAL, command=l.yview)
    s.grid(column=2, row=1, rowspan=6, sticky=(N,S))
    l['yscrollcommand'] = s.set

    txt=StringVar()
    lab=ttk.Label(kentrikoframe, textvariable=txt)
    lab.grid(column=1, columnspan=2,  row=7)
    for row in recs:
        l.insert(END,  row[0])
    txt.set('Πληροφορίες')
    l.bind('<Double-1>', setme )
    syndesi_tt.close()    
    
    
    #Δημιουργία των πεδίων
    ttk.Label(kentrikoframe,  text='Α/Α:').grid(column=3, row=1, sticky=W)
    tkaa = ttk.Entry(kentrikoframe, width=9, state=DISABLED, textvariable=aa)
    tkaa.grid(column = 4, row = 1, sticky =(W, E))
    
    ttk.Label(kentrikoframe,  text='ΑΦΜ:').grid(column=3, row=2, sticky=W)
    tkafm = ttk.Entry(kentrikoframe, width=9, textvariable=afm) #,textvariable=afm
    tkafm.grid(column = 4, row = 2, sticky =(W, E))

    nm=ttk.Label(kentrikoframe, textvariable=epixirisi, font=('', '', 'bold'))
    nm.grid(column=3, row =3, columnspan=4, sticky=(W,E))
    s=ttk.Separator(kentrikoframe)
    s.grid(row=8, column=1, columnspan=5, sticky=(W,E))
    
    ttk.Label(kentrikoframe,  text='Αριθμός Απόδειξης:').grid(column=3, row=4, sticky=W)
    tkgar_apod = ttk.Entry(kentrikoframe, width=10,  textvariable= ar_apod ) #,textvariable=afm
    tkgar_apod.grid(column = 4, row = 4, sticky =(W, E))

    ttk.Label(kentrikoframe,   text='Ημερομηνία:').grid(column=3, row=5, sticky=W)
    tkhmeromhnia = ttk.Entry(kentrikoframe, width= 10,  textvariable = hmerominia) #,textvariable=afm
    tkhmeromhnia.grid(column = 4, row = 5, sticky =(W, E))
    
    ttk.Label(kentrikoframe,  text='Τύπος Αγοράς: ').grid(column=3, row=6, sticky=W)
    tktyposagoras = ttk.Combobox(kentrikoframe,  width = 20, textvariable = typosagoras)
    tktyposagoras.grid(column = 4, row = 6, columnspan = 2, sticky =W)
    tktyposagoras['values']= fillcombo(vasi)
    ttk.Label(kentrikoframe,  text='Ποσό: ').grid(column=3, row=7, sticky=W)
    tkposo = ttk.Entry(kentrikoframe, width= 10,  textvariable = gposo) 
    tkposo.grid(column = 4, row = 7, sticky =(W, E))
    
    #Δημιουργία κουμπιών
    ttk.Button(kentrikoframe, text= 'Διαγραφή', command = lambda:del_record(vasi, l.curselection())).grid(column =1, row =9, sticky=W)
    ttk.Button(kentrikoframe, text='Ενημέρωση', command=updateme).grid(column=2, row=9, sticky=W)
    ttk.Button(kentrikoframe, text= 'Κλείσιμο', command = root.destroy).grid(column =4, row =9, sticky=(E,W))
    
    for child in kentrikoframe.winfo_children():
        child.grid_configure(padx=6, pady=6)
    
    root.update_idletasks()
    screen_width=root.winfo_screenwidth()
    screen_hight=root.winfo_screenheight()
    w = root.winfo_width()
    h = root.winfo_height()
    root.geometry("%dx%d%+d%+d" % (w, h, (screen_width-w)/2, (screen_hight-h)/2+20))
    
    root.wait_window()

if __name__ == '__main__':
    tropo_apodixis()
