#!/usr/bin/env python3
#-*- coding: utf-8 -*-

#==================================================================================
#  Copyright:
#            
#      Copyright (C) 2010 Konstas Marmatakis <marmako@gmail.com>
#
#   License:
#  
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License version 2 as
#      published by the Free Software Foundation.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this package; if not, write to the Free Software
#      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#================================================================================== 


import sqlite3
from tkinter import *
from tkinter import ttk, messagebox

vasi = '../data/apodixis.db'

def epixirisisdata(gafm='',gdoy='', geponimia='',gdieythinsi='',gthlefono='', d=False ):
  
    root =Tk()
    root.title('Καταχώρηση Επιχειρήσεων')
    
    def apothikeysh(*dedomena):
        syndesi = sqlite3.connect(vasi)
        curr = syndesi.cursor()
        curr.execute("INSERT INTO epixirisis (afm, doy, eponimia, dieythinsi, thlefono) VALUES (?, ?, ?, ?, ?)",(str(afm.get()), str(doy.get()), str(eponimia.get()), str(dieythinsi.get()), str(thlefono.get())))
        syndesi.commit()
        syndesi.close()
        minima ='Η επιχείρηση με ΑΦΜ: {0} καταχωρήθηκε.\n\
        ΔΟΥ:\t{1}\n\
        ΕΠΩΝΥΜΙΑ: {2}\n\
        ΔΙΕΥΘΥΝΣΗ: {3}\n\
        ΤΗΛΕΦΩΝΟ: {4}'.format(str(afm.get()), str(doy.get()), str(eponimia.get()), str(dieythinsi.get()), str(thlefono.get()))
        
        messagebox.showinfo("Έγινε Καταχώριση", minima)
        kentrikoframe.quit()
    kentrikoframe = ttk.Frame(root)
    kentrikoframe.grid(column=0, row=0, sticky=(N, W, S, E))
    kentrikoframe.columnconfigure(0, weight=1)
    kentrikoframe.rowconfigure(0, weight =1)

    afm = StringVar()
    doy = StringVar()
    eponimia = StringVar()
    dieythinsi = StringVar()
    thlefono = StringVar()
    
    ttk.Label(kentrikoframe, text='ΑΦΜ:').grid(column=1, row=1, sticky=W)
    tkafm = ttk.Entry(kentrikoframe, width=9, textvariable= afm) #,textvariable=afm
    tkafm.grid(column = 2, row = 1, sticky =(W, E))

    ttk.Label(kentrikoframe, text='ΔΟΥ:').grid(column=1, row=2, sticky=W)
    tkdoy = ttk.Entry(kentrikoframe, width=20,textvariable= doy ) #,textvariable=afm
    tkdoy.grid(column = 2, row = 2, sticky =(W, E))

    ttk.Label(kentrikoframe, text='Επωνυμία:').grid(column=1, row=3, sticky=W)
    tkeponimia = ttk.Entry(kentrikoframe, width= 50,textvariable=eponimia ) #,textvariable=afm
    tkeponimia.grid(column = 2, row = 3, sticky =(W, E))

    ttk.Label(kentrikoframe, text='Διεύθυνση: ').grid(column=1, row=4, sticky=W)
    tkdieythinsi = ttk.Entry(kentrikoframe, width= 50,textvariable=dieythinsi ) #,textvariable=afm
    tkdieythinsi.grid(column = 2, row = 4, sticky =(W, E))

    ttk.Label(kentrikoframe, text='Τηλέφωνο: ').grid(column=1, row=5, sticky=W)
    tktilefono = ttk.Entry(kentrikoframe, width= 10,textvariable= thlefono ) #,textvariable=afm
    tktilefono.grid(column = 2, row = 5, sticky =(W, E))

    ttk.Button(kentrikoframe, text='Καταχώρηση', command=apothikeysh).grid(column=1, row=6, sticky=W)
    ttk.Button(kentrikoframe, text= 'Ακύρωση', command = kentrikoframe.quit).grid(column =2, row =6, sticky=W)
    
    if d==True:
        afm.set(gafm)
        doy.set(gdoy)
        eponimia.set(geponimia)
        dieythinsi.set(gdieythinsi)
        thlefono.set(gthlefono)
    
    for child in kentrikoframe.winfo_children():
        child.grid_configure(padx=5, pady=5)

    root.update_idletasks()
    screen_width=root.winfo_screenwidth()
    screen_hight=root.winfo_screenheight()
    w = root.winfo_width()
    h = root.winfo_height()
    root.geometry("%dx%d%+d%+d" % (w, h, (screen_width-w)/2, (screen_hight-h)/2))
    tkafm.focus()
    root.mainloop()
    
    
if __name__=='__main__':
    
    if len(sys.argv)>1:
        epixirisisdata(gafm=str(sys.argv[1]), d= True)
    else:
        epixirisisdata()   