#!/usr/bin/env python3
#-*-coding: utf-8 -*-
#==================================================================================
#  Copyright:
#            
#      Copyright (C) 2010 - 2014 Konstas Marmatakis <marmako@gmail.com>
#
#   License:
#  
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License version 2 as
#      published by the Free Software Foundation.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this package; if not, write to the Free Software
#      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#================================================================================== 

import collections
import sqlite3
from tkinter import Frame, StringVar, IntVar, Tk, ttk, DoubleVar
from tkinter.constants import BOTTOM, LEFT, RIGHT, TOP, N, S, W, E, DISABLED,\
    NORMAL
from libs.connectdb import connectsqlite
from guinterface.tkuiapodixis import vasi
'''
Created on Nov 17, 2010
Revised on 10 Nov, 2013 21:37

@author: kostas
'''

__enimerothike__ = '17-01-2014 15:48'

class cdialog:
    '''
    Κλάση για τη δημιουργία προσαρμοσμένου διαλόγου με Combobox.
    Παίρνει δεδομένα από βάση δεδομένων.
    '''
    def __init__(self, top, database):
        self.afm = ""
        self.xr = 0
        self.q = ''
        self.querysinolo = ''
        self.v = ()
        self.rcs = []
        self.t_afm = StringVar()
        self.xrono = StringVar()
        self.sinolo = StringVar()
        self.chknames = {}
        self.d = {}
        self.vals = []
        self.database = database
        top.title('Εκτύπωση')
        self.top = top
        self.createwidgets()
    
    
    def createwidgets(self):
        
        st = ttk.Style()
        st.configure("fnt.TButton",  background= '#c95d13', font=("DejaVu Sans", 10, "bold"))
#         st.configure("fnt.TFrame", background= '#c95d13')
            
        frame_e = ttk.Frame(self.top, style="fnt.TFrame")
        frame_e.grid(column=0, row=0, sticky=(N, W))
        frame_e.columnconfigure(0, weight=1)
        frame_e.rowconfigure(0, weight=1)
        self.frame_e = frame_e
        
        askafm = ttk.Label(frame_e,  text='Παρακαλώ δώστε το ΑΦΜ:')
        askafm.configure(font=("DejaVu Sans", 10, "bold"))
        askafm.grid(column=0, row=0, sticky=W)
        
        tkafmp = ttk.Combobox(frame_e, width=30, textvariable=self.t_afm)
        tkafmp.grid(column=1, row=0, sticky=E)
        self.tkafmp = tkafmp
        self.filllst()
        if len(self.rcs) > 0:
            tkafmp['values'] = self.rcs
            tkafmp.focus_force()
            tkafmp.bind('<<ComboboxSelected>>', self.filafm)
        
        askxrono = ttk.Label(frame_e, text='Παρακαλώ δώστε το έτος:')
        askxrono.configure(font=("DejaVu Sans", 10, "bold"))
        askxrono.grid(column=0, row=1, sticky=W)
        
        tkxrono = ttk.Combobox(frame_e, width=30, textvariable=self.xrono)
        tkxrono.grid(column=1, row=1, sticky=E)
        tkxrono['values'] = self.filllstx()
        tkxrono.current(0)
        
        tkxrono.bind('<<ComboboxSelected>>', self.filxrono)
        self.create_form()
        
        lblsynoloapodix = ttk.Label(self.frame_e, text='Σύνολο αποδείξεων', textvariable=self.sinolo)
        lblsynoloapodix.grid(row=2, column=0, columnspan=2, sticky=W)
        
        btnSetVal = ttk.Button(self.top, text='Επιλογή Όλων', style='fnt.TButton', command=self.checked_all)
        btnSetVal.grid(column=0, row=2, sticky=E)
        self.btnSetVal = btnSetVal
       
        btnRemoveVal = ttk.Button(self.top, text='Αποεπιλογή Όλων', style='fnt.TButton', command=self.unchecked_all)
        btnRemoveVal.grid(column=0, row=2, sticky=E)
        
        self.btnRemoveVal = btnRemoveVal
        

        tkbtn = ttk.Button(self.top, text='Εκτύπωση', style="fnt.TButton", command=self.displayvalues)
##        tkbtn.config(font=("DejaVu Sans", 10, "bold"))
        tkbtn.grid(column=0, row=2, sticky=W)
        
        for child in self.top.winfo_children():
            child.grid_configure(padx=2, pady=2)
        self.btnRemoveVal.grid_forget()      
        self.top.update_idletasks()
        screen_width = self.top.winfo_screenwidth()
        screen_hight = self.top.winfo_screenheight()
        w = self.top.winfo_width()
        h = self.top.winfo_height()
        self.top.geometry("%dx%d%+d%+d" % (w, h, (screen_width - w) / 2, (screen_hight - h) / 2))
        self.top.grab_set()
        self.top.focus_set()
    
    def checked_all(self):
        for key, value in self.chknames.items():
            value.set(key["onvalue"])
#             self.vals.append(value.get())
#             key['state'] = DISABLED
        self.btnSetVal.grid_forget()
        self.btnRemoveVal.grid(column=0, row=2, sticky=E)
       
    
    def unchecked_all(self):
        for key, value in self.chknames.items():
            value.set(key["offvalue"])
#             key['state'] = NORMAL
        self.vals.clear()
        self.btnSetVal.grid(column=0, row=2, sticky=E)
        self.btnRemoveVal.grid_forget()
    
    def create_form(self):
        count = 0
        syndesi_tt,  cur = connectsqlite(self.database)
        #cur.execute("SELECT perigrafi, eidos_id FROM eidos_agoras ORDER BY eidos_id")
        cur.execute("""SELECT DISTINCT eidos_agoras.perigrafi,
                eidos_agoras.eidos_id
           FROM eidos_agoras
                LEFT OUTER JOIN apodixis
          WHERE eidos_agoras.eidos_id = apodixis.typos_agoras
          ORDER BY eidos_agoras.eidos_id""")
        
        for row in cur.fetchall():
            self.d[row[0]] = row[1]
         
        od = collections.OrderedDict(sorted(self.d.items()))
         
        lblfrm = ttk.LabelFrame(self.top,  text='Επιλογή Κατηγρορίας Αποδείξεων')
        lblfrm.grid(row=0, column=1, sticky=W+E+N+S)
        lblfrm.rowconfigure(0, weight=1)
        lblfrm.columnconfigure(0, weight=1)
        
        for key, value in od.items():
            varname = 'var' + str(value)
            varname = IntVar()
            chkname = 'chck' + str(value)
            chkname = ttk.Checkbutton(lblfrm, text=key, onvalue=value, offvalue=0, variable=varname)
            chkname.grid(row=count, column=0, sticky=W)
            self.chknames[chkname] = varname
            count += 1
    
    def return_sinolo(self):
        
        syndesi_tt, curs = connectsqlite(self.database)
        try:
            curs.execute(self.querysinolo, (self.vals[0],))
        except:
            curs.execute(self.querysinolo, self.vals)
            
        recs = curs.fetchone()
        print(recs)
        syndesi_tt.close()
        self.sinolo.set("Σύνολο Αποδείξεων: {}.".format(recs[0]))
        self.top.update()
            
    def displayvalues(self):
            import time
            for key, value in self.chknames.items():
                    if value.get() > 0:
                            self.vals.append(value.get())
            if len(self.vals) > 0:
                self.v = self.vals
                self.q = "SELECT apodixis.aa, apodixis.afm, epixirisis.eponimia, apodixis.arithmos_apod, eidos_agoras.perigrafi,\
             apodixis.ddate, apodixis.poso FROM apodixis INNER JOIN eidos_agoras ON eidos_agoras.eidos_id\
              = apodixis.typos_agoras INNER JOIN epixirisis ON epixirisis.afm = apodixis.afm where apodixis.oik_etos=? AND apodixis.typos_agoras IN ({0}) ORDER BY apodixis.aa".format(','.join('?'*len(self.vals)))
                self.querysinolo = "SELECT ROUND(SUM(poso),2) FROM apodixis WHERE oik_etos=? AND typos_agoras IN ({0})".format(','.join('?'*len(self.vals)))
            else:
                self.q = "SELECT apodixis.aa, apodixis.afm, epixirisis.eponimia, apodixis.arithmos_apod, eidos_agoras.perigrafi,\
             apodixis.ddate, apodixis.poso FROM apodixis INNER JOIN eidos_agoras ON eidos_agoras.eidos_id\
              = apodixis.typos_agoras INNER JOIN epixirisis ON epixirisis.afm = apodixis.afm where apodixis.oik_etos=? ORDER BY apodixis.aa"
                self.querysinolo = "SELECT ROUND(SUM(poso),2) FROM apodixis WHERE oik_etos=?"
       
            self.vals.insert(0, int(self.xrono.get()))
            self.return_sinolo()
            s = self.t_afm.get()
                  
            if len(s) > 0:
                s = s.split()
                self.afm = s[0]
                self.vals.insert(0, self.afm)
            else:
                self.afm = ''
            
            self.v = tuple(self.vals)
            
            time.sleep(12)
            self.top.destroy()
            
    def filafm(self, event):
        try:
            self.afm = self.t_afm.get().split()[0]
        except:
            pass
    
    def filxrono(self, event):
        self.xr = self.xrono.get()
        
    def filllst(self):
        query = 'SELECT afm_pelati|| " " || eponimo || " " || onoma as onep FROM pelates ORDER BY onep'
        syndesi_tt,  curs = connectsqlite(self.database) 
        
        try:
            curs.execute(query)
        except sqlite3.OperationalError:
            self.tkafmp['state'] = DISABLED
            
            
        recs = curs.fetchall()

        for row in recs:
            self.rcs.append(str(row[0]))
        curs.close()
        syndesi_tt.close()
        return self.rcs
    
    def filllstx(self):
        query = 'SELECT DISTINCT oik_etos FROM apodixis ORDER BY oik_etos DESC'
        syndesi_tt, curs = connectsqlite(self.database)
        curs.execute(query)
        recs = curs.fetchall()
        rcs = []
        for row in recs:
            rcs.append(str(row[0]))
        syndesi_tt.close()
        return rcs

    def re_afm(self):
        s = self.t_afm.get()
        
        self.xr = self.xrono.get()
        if len(s) > 0:
            s = s.split()
            self.afm = s[0]
        else:
            self.afm = ''
        self.top.destroy()



if __name__ == '__main__':
    import pprint
    root = Tk()
#    root.geometry=("100x100+100+50")
    
    D = cdialog(root, vasi)
    
    root.mainloop()    
##    root.wait_window()
    apantisi = D.afm or None, D.xr or None, D.v
##    root.destroy()
    print ("Έπιασα: ", apantisi)
    pprint.pprint(D.q, width=50)
    input()
