#!/usr/bin/env python3
#-*-coding: utf-8 -*-

#==================================================================================
#  Copyright:
#            
#      Copyright (C) 2010 Konstas Marmatakis <marmako@gmail.com>
#
#   License:
#  
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License version 2 as
#      published by the Free Software Foundation.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this package; if not, write to the Free Software
#      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#================================================================================== 

'''
Created on 25 Φεβ 2010
Revised on 13-02-2013
@author:    Konstas Marmatakis
'''
__enimerothike__ = '19-01-2014 13:02'

from tkinter import ttk, messagebox, Listbox, Toplevel, StringVar, DoubleVar,\
    Text, PhotoImage, IntVar, TclError
from tkinter.messagebox import showerror
from tkinter.constants import END, E, N, S, W, DISABLED, NORMAL, FLAT, CENTER,\
    VERTICAL
import os, webbrowser
import sqlite3
from datetime import date
from libs.lib import wcreate_vasi, check_if_exist, pare_dedomena, check_afm,\
    conveisodohmerominias, agora_int, check_sum, fillcombo,\
    insert_agora, getplatform , create_dir, filloik_etos
    
from libs.storedata import storedata
from libs.autocompletition_apodixis import AutocompleteEntry

__version__='0.4.23'
__author__='Konstas Marmatakis'


diaxoristiko =os.sep
monopati = os.getcwd()
# vasi ='data/apodixis.db'
vasi = os.path.normpath(os.path.join(create_dir(), 'apodixis.db'))
copyrightfile = 'docs/gpl.txt'

def check_vasi(databaseonoma):    
    if os.path.exists(databaseonoma) == False:
        if messagebox.askyesno('Δημιουργία Βάσης', 'Δεν υπάρχει βάση δεδομένων.\nΘα γίνει εγκατάσταση.\n') == True:
            wcreate_vasi(databaseonoma)
        else:
            try:
                os.unlink(databaseonoma)
                os.removedirs(os.path.normpath(create_dir()))
            except:
                if os.path.exists(databaseonoma):
                    messagebox.showerror("Σφάλμα", "Δεν διαγράφηκαν τα άδεια αρχεία.\nΔιαγράψτε το αρχείο\n{0}\nμε το χέρι.".format(databaseonoma))
                else:
                    pass


def apodixisdata():
    # Αρχικοποίηση της φόρμας
    root = Toplevel()
    root.title('Καταχώρηση Αποδείξεων')
    
    global afm
    def insert_apodixi(*dedomena): #(gafm, gar_apod, ghmerominia, gtagoras, gposo):
        import locale
        locale.setlocale(locale.LC_ALL, '')
        a_f_m = str(afm.get()) #input('Δώστε το ΑΦΜ της επιχείρησης: ')
       
        if check_if_exist(a_f_m, vasi):
            dedome = pare_dedomena(a_f_m, vasi)
            doy = dedome[1] #@UnusedVariable
            eponimia = dedome[2] #@UnusedVariable
            dieythinsi = dedome[3] #@UnusedVariable
            thlefono = dedome[4] #@UnusedVariable
        else:
            if check_afm(a_f_m):
#
                epixirisisdata(gafm = a_f_m, d=True)
            else: 
                print('Το ΑΦΜ: {0} δεν είναι έγκυρο.\nΈξοδος.'.format(a_f_m))
                return False

        dedome = pare_dedomena(a_f_m, vasi)
        doy = dedome[1]
        
        eponimia = dedome[2]
        dieythinsi = dedome[3]
        thlefono = dedome[4]  
        print('Στοιχεία της επιχείρησης:\n')
        print('ΑΦΜ: {0}\t ΔΟΥ: {1}\nΕπωνυμία: {2}\nΔιεύθυνση: {3} Τηλέφωνο: {4}\n'.format(a_f_m, doy, eponimia, dieythinsi, thlefono))     
        
    #######################################################
        arit_apo = str(ar_apod.get())
        hmerom = str(hmerominia.get())
        if hmerom == '':
            hmerom = date.today()
            #hmerom = strftime('%Y', hmerom.timetuple())

        else:
            hmerom = conveisodohmerominias(hmerom)
       
        try:
            poso = float(gposo.get()) #input('Δώστε το ποσό της απόδειξης: ')
        except ValueError:
            try:
                poso = float(tkposo.get().replace(',', '.'))
                gposo.set(poso)
            except:
                messagebox.showinfo('Σφάλμα Καταχώρησης', 'Δημιουργήθηκε σφάλμα κατά την καταχ΄ώρηση. Παρακαλώ ελέγξτε τα δεδομ΄ένα που καταχωρήσατε.', parent=root)
                tkposo.focus_set()
                tkposo.select_range(0, END)
                return

        typos = agora_int(vasi, str(typosagoras.get())) #typos_agoras(vasi)
        
        minima = storedata(vasi, 'apodixis', hmerom, arit_apo, a_f_m, doy, typos, poso)
        if len(minima) > 0:
            messagebox.showinfo('Η απόδειξη καταχωρήθηκε', minima, parent=root)
            sinoloapo.set('Το σύνολο των αποδείξεων είναι: {0}.'.format(check_sum(vasi)))
        else:
            messagebox.showerror("Σφάλμα", "Δημιουργήθηκε σφάλμα κατά την καταχώρηση των στοιχείων της απόδειξης.\n\nΠαρακαλώ ελέγξτε τα στοιχεία της απόδειξης και προσπαθείστε ξανά.", parent=root)
    
    def keyenter(event): ### (2)
        root.destroy()
    
    def focus_out(event):
        if check_if_exist(afm.get(), vasi):
            query= "SELECT afm, eponimia FROM epixirisis WHERE afm = ?"
            syndesi =sqlite3.connect(vasi)
            curr = syndesi.cursor()
            curr.execute(query, (afm.get(),))
            result= curr.fetchall()
            try:
                for row in result:
                    res=row[1]
                    epixirisi.set(res[0:45])
            except:
                epixirisi.set('Η επιχείριση δεν είναι καταχωρημένη.')
            finally:
                syndesi.close()
        else:
            strm='Το ΑΦΜ: {0}, που πληκτρολογήσατε δεν είναι καταχωρημένο\nή το γράψατε λανθασμένα.\nΘέλετε να καταχωρηθεί;'.format(afm.get())
            answ = messagebox.askyesno('Το ΑΦΜ δεν υπάρχει', strm, parent=root)
            if answ ==True:
                epixirisisdata(gafm=afm.get(), d=True)
                tkafm.focus()
            else:
                tkafm.delete(0, END)
                #tkafm.focus()
                #tkafm.unbind('<FocusOut>')

#        epixirisi.set(tkafm.get())
        
    def clear_fields(event):
            tkafm.delete(0, END)
            tkgar_apod.delete(0, END)
            tkhmeromhnia.delete(0, END)
            tktyposagoras.delete(0, END)
            tkposo.delete(0, END)
            epixirisi.set('')
            tkafm.focus()
            tkafm.bind('<FocusOut>', focus_out)
            kat['state'] = NORMAL
            
    def complete_list(vasi):
        compl_list = []
        query = "SELECT afm FROM epixirisis ORDER BY afm"
        syndesi = sqlite3.connect(vasi)
        curr = syndesi.cursor()
        curr.execute(query)
        
        result = curr.fetchall()
        
        try:
            for row in result:
                compl_list.append(row[0])
        except:
            pass
        finally:
            curr.close()
            syndesi.close()
        return compl_list
            
    kentrikoframe = ttk.Frame(root)
    kentrikoframe.grid(column=0, row=0, sticky=(N, W, S, E))
    kentrikoframe.columnconfigure(0, weight=1)
    kentrikoframe.rowconfigure(0, weight =1)
    
    afm = StringVar()
    ar_apod = StringVar()
    hmerominia = StringVar()
    typosagoras = StringVar()
    gposo = DoubleVar()
    epixirisi=StringVar()
    sinoloapo=StringVar()
    #Δημιουργία των πεδίων
    ttk.Label(kentrikoframe,  text='ΑΦΜ:').grid(column=1, row=1, sticky=W)
    tkafm = AutocompleteEntry(kentrikoframe, width=9, textvariable=afm) #,textvariable=afm
    tkafm.grid(column = 2, row = 1, sticky =(W, E))
    tkafm.bind('<FocusOut>', focus_out)
    l = complete_list(vasi)
    tkafm.set_completion_list(l)
    
    nm=ttk.Label(kentrikoframe, textvariable=epixirisi, font=( 'bold'))
    nm.grid(column=1, row =2, columnspan=4, sticky=(W,E))
    s=ttk.Separator(kentrikoframe)
    s.grid(row=8, column=1, columnspan=4, sticky=(W,E))
    sinapo=ttk.Label(kentrikoframe, textvariable=sinoloapo)
    sinoloapo.set('Το σύνολο των καταχωρημένων αποδείξεων είναι: {0}.'.format(check_sum(vasi)))
    sinapo.grid(column=1, row =9, columnspan=4, sticky=(W,E))
    
    ttk.Label(kentrikoframe,  text='Αριθμός Απόδειξης:').grid(column=1, row=3, sticky=W)
    tkgar_apod = ttk.Entry(kentrikoframe, width=10,  textvariable= ar_apod ) #,textvariable=afm
    tkgar_apod.grid(column = 2, row = 3, sticky =(W, E))

    ttk.Label(kentrikoframe,   text='Ημερομηνία:').grid(column=1, row=4, sticky=W)
    tkhmeromhnia = ttk.Entry(kentrikoframe, width= 10,  textvariable = hmerominia) #,textvariable=afm
    tkhmeromhnia.grid(column = 2, row = 4, sticky =(W, E))
    
    ttk.Label(kentrikoframe,  text='Τύπος Αγοράς: ').grid(column=1, row=5, sticky=W)
    #tktyposagoras = ttk.Entry(kentrikoframe, width= 10, textvariable = typosagoras ) #,textvariable=afm
    tktyposagoras = ttk.Combobox(kentrikoframe,  width = 30, textvariable = typosagoras)
    tktyposagoras.grid(column = 2, row = 5, columnspan = 2, sticky =(W, E))
    tktyposagoras['values']= fillcombo(vasi)
    ttk.Label(kentrikoframe,  text='Ποσό: ').grid(column=1, row=6, sticky=W)
    tkposo = ttk.Entry(kentrikoframe, width= 10,  textvariable = gposo) #,textvariable=afm
    tkposo.grid(column = 2, row = 6, sticky =(W, E))
    
    kat=ttk.Button(kentrikoframe, text='Καταχώρηση', command=insert_apodixi)
    kat.grid(column=1, row=7, sticky=W)
    kat.bind("<Return>", insert_apodixi)
    kath=ttk.Button(kentrikoframe, text='Καθαρισμός', command=lambda:clear_fields('<Return>'))
    kath.grid(column=2, row=7, sticky=W)
    kath.bind('<Return>', clear_fields)
    
    ttk.Button(kentrikoframe, text='Ενημέρωση', command='', state=DISABLED).grid(column=3, row=7, sticky=W)
    akirosi=ttk.Button(kentrikoframe, text= 'Κλείσιμο', command = root.destroy)
    akirosi.grid(column =4, row =7, sticky=E)
    akirosi.bind('<Return>', keyenter)
   
    for child in kentrikoframe.winfo_children():
        child.grid_configure(padx=5, pady=5)
    
    root.update_idletasks()
    screen_width=root.winfo_screenwidth()
    screen_hight=root.winfo_screenheight()
    w = root.winfo_width()
    h = root.winfo_height()
    root.geometry("%dx%d%+d%+d" % (w, h, (screen_width-w)/2, (screen_hight-h)/2+20))
    root.grab_set()
    root.focus_set()
    tkafm.focus()
#    root.mainloop()
    root.wait_window()

def epixirisisdata(gafm='',gdoy='', geponimia='',gdieythinsi='',gthlefono='', d=False ):
    root01 =Toplevel()
    root01.title('Καταχώρηση Επιχειρήσεων')
    oldafm=''
    def apothikeysh(*dedomena):
        syndesi = sqlite3.connect(vasi)
        curr = syndesi.cursor()
        curr.execute("INSERT INTO epixirisis (afm, doy, eponimia, dieythinsi, thlefono) VALUES (?, ?, ?, ?, ?)",(str(afm.get()), str(doy.get()), str(eponimia.get()), str(dieythinsi.get()), str(thlefono.get())))
        syndesi.commit()
        syndesi.close()
        minima ='Η επιχείρηση με ΑΦΜ: {0} καταχωρήθηκε.\n\
        ΔΟΥ:\t{1}\n\
        ΕΠΩΝΥΜΙΑ: {2}\n\
        ΔΙΕΥΘΥΝΣΗ: {3}\n\
        ΤΗΛΕΦΩΝΟ: {4}'.format(str(afm.get()), str(doy.get()), str(eponimia.get()), str(dieythinsi.get()), str(thlefono.get()))
        
        messagebox.showinfo("Έγινε Καταχώριση", minima, parent=root01)
    
    def clearme():
        tkafm.delete(0, END)
        tkdoy.delete(0, END)
        tkeponimia.delete(0, END)
        tkdieythinsi.delete(0, END)
        tktilefono.delete(0, END)
    
    def euresi():
        
        if tkafm.get() !='':
            oldafm=tkafm.get()
            query= "SELECT * FROM epixirisis WHERE afm = '"+ afm.get() +"'"
            try:
                syndesi =sqlite3.connect(vasi)
                curr = syndesi.cursor()
                curr.execute(query)
            except:
                showerror('Σφάλμα', 'Δημιουργήθηκε σφάλμα.', parent=root01)
            finally:
                result= curr.fetchall()
                for row in result:
                    afm.set(row[0])
                    doy.set(row[1])
                    eponimia.set(row[2])
                    dieythinsi.set(row[3])
                    thlefono.set(row[4])
                    syndesi.commit()
                    syndesi.close()
        kataxorisi.configure(state=DISABLED)
        tkafm.configure(state=DISABLED)
        return oldafm
    
    def updateme(*dedomena):
        if len(oldafm)>0:
            a_f_m=oldafm
        else:
            a_f_m=str(afm.get())
        query="UPDATE epixirisis SET afm = ?, doy = ?, eponimia = ?, dieythinsi = ?, thlefono = ? WHERE afm =?"
        
        syndesi =sqlite3.connect(vasi)
        curr = syndesi.cursor()
        curr.execute(query , (str(afm.get()), str(doy.get()), str(eponimia.get()), str(dieythinsi.get()), str(thlefono.get()), str(a_f_m)))
        syndesi.commit()
        syndesi.close()
        minima ='Τα στοιχεία της επιχείρησης με ΑΦΜ: {0} καταχωρήθηκε.\n\
        ΔΟΥ:\t{1}\n\
        ΕΠΩΝΥΜΙΑ: {2}\n\
        ΔΙΕΥΘΥΝΣΗ: {3}\n\
        ΤΗΛΕΦΩΝΟ: {4}'.format(str(afm.get()), str(doy.get()), str(eponimia.get()), str(dieythinsi.get()), str(thlefono.get()))
        
        messagebox.showinfo("Έγινε Ενημέρωση", minima, parent=root01)
        kataxorisi.configure(state= NORMAL)
        tkafm.configure(state=NORMAL)
                
    kentrikoframe = ttk.Frame(root01)
    kentrikoframe.grid(column=0, row=0, sticky=(N, W, S, E))
    kentrikoframe.columnconfigure(0, weight=1)
    kentrikoframe.rowconfigure(0, weight =1)

    afm = StringVar()
    doy = StringVar()
    eponimia = StringVar()
    dieythinsi = StringVar()
    thlefono = StringVar()
    
    ttk.Label(kentrikoframe, text='ΑΦΜ:').grid(column=0, row=0, sticky=W)
    tkafm = ttk.Entry(kentrikoframe, width=9, textvariable= afm) #,textvariable=afm
    tkafm.grid(column=1, row =0, columnspan=2, sticky =(W, E))

    ttk.Label(kentrikoframe, text='ΔΟΥ:').grid(column=0, row=1, sticky=W)
    tkdoy = ttk.Entry(kentrikoframe, width=20,textvariable= doy ) #,textvariable=afm
    tkdoy.grid(column=1, row=1, columnspan=2, sticky =(W, E))

    ttk.Label(kentrikoframe, text='Επωνυμία:').grid(column=0, row=2, sticky=W)
    tkeponimia = ttk.Entry(kentrikoframe, width= 50,textvariable=eponimia ) #,textvariable=afm
    tkeponimia.grid(column=1, row=2, columnspan=2, sticky =(W, E))

    ttk.Label(kentrikoframe, text='Διεύθυνση: ').grid(column=0, row=3, sticky=W)
    tkdieythinsi = ttk.Entry(kentrikoframe, width= 50,textvariable=dieythinsi ) #,textvariable=afm
    tkdieythinsi.grid(column=1, row=3, columnspan=2, sticky =(W, E))

    ttk.Label(kentrikoframe, text='Τηλέφωνο: ').grid(column=0, row=4, sticky=W)
    tktilefono = ttk.Entry(kentrikoframe, width= 10,textvariable= thlefono ) #,textvariable=afm
    tktilefono.grid(column=1, row=4, columnspan=2, sticky =(W, E))

    kataxorisi=ttk.Button(kentrikoframe, text='Καταχώρηση', command=apothikeysh)
    kataxorisi.grid(column=0, row=5, sticky=W)
    kataxorisi.bind('<Return>', apothikeysh)
    evresi=ttk.Button(kentrikoframe, text='Εύρεση', command=euresi)
    evresi.grid(column=1, row=5, sticky=W)
    evresi.bind('<Return>', euresi)
    ttk.Button(kentrikoframe, text='Ενημέρωση', command=updateme).grid(column=2, row=5, sticky=W)
    ttk.Button(kentrikoframe, text='Καθαρισμός', command=clearme).grid(column=2, row=5, sticky=E)
    ttk.Button(kentrikoframe, text= 'Κλείσιμο', command = root01.destroy).grid(column=4, row=5, sticky=E)
    
    if d==True:
        afm.set(gafm)
        doy.set(gdoy)
        eponimia.set(geponimia)
        dieythinsi.set(gdieythinsi)
        thlefono.set(gthlefono)
    
    for child in kentrikoframe.winfo_children():
        child.grid_configure(padx=2, pady=2)

    root01.update_idletasks()
    screen_width=root01.winfo_screenwidth()
    screen_hight=root01.winfo_screenheight()
    w = root01.winfo_width()
    h = root01.winfo_height()
    root01.geometry("%dx%d%+d%+d" % (w, h, (screen_width-w)/2, (screen_hight-h)/2))
    
    root01.grab_set()
    root01.focus_set()
    tkafm.focus()
    root01.wait_window()


def typoidata():
    roo02 =Toplevel()
    roo02.title('Καταχώρηση Τύπων Αγορών')
    
    perigrafi =StringVar()
    
    def doit(*stoixeia):
        insert_agora(vasi, str(perigrafi.get()))
        messagebox.showinfo('Έγινε Καταχώρηση', 'Καταχωρήθηκε η εγγραφή:\n {0}.'.format(str(perigrafi.get())), parent=roo02)
    kentrikoframe = ttk.Frame(roo02)
    kentrikoframe.grid(column=0, row=0, sticky=(N, W, S, E))
    kentrikoframe.columnconfigure(0, weight=1)
    kentrikoframe.rowconfigure(0, weight =1)
    
    ttk.Label(kentrikoframe, text='Κωδικός:').grid(column=1, row=1, sticky=W)
    tkkodikos = ttk.Entry(kentrikoframe, width=9, state=DISABLED ) #,textvariable=afm
    tkkodikos.grid(column = 2, row = 1, sticky =(W, E))

    ttk.Label(kentrikoframe, text='Περιγραφή:').grid(column=1, row=2, sticky=W)
    tkperigrafi = ttk.Entry(kentrikoframe, width=20, textvariable=perigrafi ) #,textvariable=afm
    tkperigrafi.grid(column = 2, row = 2, sticky =(W, E))
    
    ttk.Button(kentrikoframe, text='Καταχώρηση', command=doit).grid(column=1, row=6, sticky=W)
    ttk.Button(kentrikoframe, text= 'Κλείσιμο', command = roo02.destroy).grid(column =2, row =6, sticky=W)
    
    
    for child in kentrikoframe.winfo_children():
        child.grid_configure(padx=5, pady=5)
    
    roo02.update_idletasks()
    screen_width=roo02.winfo_screenwidth()
    screen_hight=roo02.winfo_screenheight()
    w = roo02.winfo_width()
    h = roo02.winfo_height()
    roo02.geometry("%dx%d%+d%+d" % (w, h, (screen_width-w)/2, (screen_hight-h)/2))
    roo02.grab_set()
    roo02.focus_set()
    tkkodikos.focus()
    roo02.wait_window()

def peri():
    roo03 =Toplevel()
    roo03.title('Περί Αποδείξεων')
    roo03.resizable(0, 0)
    try:
        roo03.wm_attributes('-toolwindow', 1)
    except:
        pass
    
    def keyenter(event): ### (2)
        roo03.destroy()
    
    def gopython(event):
        webbrowser.open('http://www.python.org', autoraise=True)
        
    msg="""
  Copyright:
            
       Copyright (C) 2010 Konstas Marmatakis <marmako@gmail.com>
 
   License:
   
      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License version 2 as
      published by the Free Software Foundation.
 
      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.
 
      You should have received a copy of the GNU General Public License
      along with this package; if not, write to the Free Software
      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
      """
    
    kentrikoframe = ttk.Frame(roo03)
    kentrikoframe.grid(column=0, row=0, sticky=(N, W, S, E))
    kentrikoframe.columnconfigure(0, weight=1)
    kentrikoframe.rowconfigure(0, weight =1)
    
#    style= ttk.Style()
#    style.configure("b.TLabel",  padding=5, font=("Arial",11,""), width=50, height=20, justify=LEFT)
#    t=ttk.Label(kentrikoframe, style="b.TLabel", text=msg)
#    t.grid(column=1, row=1)
    t=Text(kentrikoframe, height=20, bg='#d9d9d9', relief=FLAT)
    t.grid(column=1, row=1, sticky=(N,S))
    t.insert(1.0, msg)
    t.insert(END, '\n')
    t.configure(state=DISABLED)
    img=PhotoImage(file='images/python-powered.gif')
#    t.image_create(END, image=img)
    ph=ttk.Label(kentrikoframe, cursor='hand2', image=img, justify=CENTER)
    ph.grid(column =1, row =2)
    ph.bind('<Button-1>', gopython)
    
    koumpi=ttk.Button(kentrikoframe, text= 'Κλείσιμο', command = roo03.destroy)
    koumpi.grid(column=1, row=3)
    koumpi.bind('<Return>', keyenter)
    
    for child in kentrikoframe.winfo_children():
        child.grid_configure(padx=5, pady=5)
    
    roo03.update_idletasks()
    screen_width=roo03.winfo_screenwidth()
    screen_hight=roo03.winfo_screenheight()
    w = roo03.winfo_width()
    h = roo03.winfo_height()
    roo03.geometry("%dx%d%+d%+d" % (w, h, (screen_width-w)/2, (screen_hight-h)/2))
    roo03.grab_set()
    roo03.focus_set()
    koumpi.focus()
    roo03.wait_window()

def tropo_apodixis():
    win = Toplevel()
    win.title('Περιήγηση Αποδείξεων')
    win.protocol("WM_DELETE_WINDOW", lambda: '')
    
    def exitme(event):
        win.destroy()
        
    aa=IntVar()
    afm = StringVar()
    ar_apod = StringVar()
    hmerominia = StringVar()
    typosagoras = StringVar()
    gposo = DoubleVar()
    epixirisi=StringVar()
    oikonomikoetos = StringVar()

    
    def updateme(*dedomena):
           
        query="UPDATE apodixis SET arithmos_apod=?, afm = ?, typos_agoras= ?, ddate =?, poso =? WHERE aa =? AND oik_etos=?"
        
        syndesi = sqlite3.connect(vasi)
        curr = syndesi.cursor()
        typos=agora_int(vasi, str(typosagoras.get()))
        curr.execute(query , ( str(ar_apod.get()), str(afm.get()), typos, str(hmerominia.get()), str(gposo.get()), str(aa.get()), oikonomikoetos.get()))
        syndesi.commit()
        syndesi.close()
        minima ='Τα στοιχεία της απόδειξης με ΑΑ: {0} καταχωρήθηκε'.format(str(aa.get()))    
        messagebox.showinfo("Έγινε Ενημέρωση", minima, parent=win)
#            kataxorisi.configure(state= NORMAL)
#            tkafm.configure(state=NORMAL) 

    def clear_fields():
            tkafm.delete(0, END)
            tkgar_apod.delete(0, END)
            tkhmeromhnia.delete(0, END)
            tktyposagoras.delete(0, END)
            tkposo.delete(0, END)
            tkaa.delete(0, END)
            tkafm.focus()
            
    def del_record(db,idx):
        if messagebox.askyesno('Διαγραφή Απόδειξης', 'Θέλετε να διαγράψετε την απόδειξη με Α/Α: {0}'.format(aa.get()), parent=win)==True:
            query= "DELETE FROM apodixis WHERE aa="+ str(aa.get())
            syndesi= sqlite3.connect(db)
            curs= syndesi.cursor()
            curs.execute(query)
            syndesi.commit()
            syndesi.close()
            l.delete(idx)
            clear_fields()
            
                    
    def set_combo(id, dbasename=vasi):
        syndesi_t = sqlite3.connect(dbasename)
        curr = syndesi_t.cursor()
        curr.execute("SELECT perigrafi FROM eidos_agoras WHERE eidos_id=" +str(id))
        rec= curr.fetchall()
        for row in rec:
            return row[0]
        syndesi_t.commit()
        syndesi_t.close()

    def grabrecs(databasename, idx, oik):
        query= "SELECT * FROM apodixis WHERE aa= ? AND oik_etos = ?"
        syndesi_tt= sqlite3.connect(databasename)
        curs= syndesi_tt.cursor()
        curs.execute(query, (idx, oik))
        recs= curs.fetchall()
        syndesi_tt.close()
        return recs

    kentrikoframe = ttk.Frame(win)
    kentrikoframe.grid(column=0, row=0, sticky=(N, W, S, E))
    kentrikoframe.columnconfigure(0, weight=1)
    kentrikoframe.rowconfigure(0, weight =1)
    
    def setlist(event=None):
        clear_fields()
        l.delete(0, END)
        syndesi_tt = sqlite3.connect(vasi)
        curs = syndesi_tt.cursor()
        
        curs.execute("SELECT aa FROM apodixis where oik_etos = ? ORDER BY aa",\
                      (oikonomikoetos.get(),))
        recs = curs.fetchall()
        for row in recs:
            l.insert(END, row[0])
        syndesi_tt.close()
        l.selection_set(0)
        setme(None)
   

# Δημιουργία του Listbox
    query= "SELECT aa FROM apodixis ORDER BY aa"
    syndesi_tt= sqlite3.connect(vasi)
    curs= syndesi_tt.cursor()
    curs.execute(query)
    recs= curs.fetchall()
    
    def setme(event):
        global records
        try:
            index = l.curselection()
            txt.set('Νο: ' + str(l.get(index)))
        except TclError as err:
            showerror('Σφάλμα', 'Δεν υπάρχουν καταχωρήσεις και σεις προσπαθήσατε να επιλέξετε.\n\nTclError: {0}'.format(err))
            return
        records = grabrecs(vasi, l.get(index), oikonomikoetos.get())
        aa.set(records[0][6])
        afm.set(records[0][1])
        ar_apod.set(records[0][0])
        hmerominia.set(records[0][4])
        gposo.set(records[0][5])
        typosagoras.set(set_combo(records[0][3]))
        
    ttk.Label(kentrikoframe, text='Έτος: ').grid(column=3, row=0, sticky=W)
    tkoiketos = ttk.Combobox(kentrikoframe, width=6, textvariable=oikonomikoetos)
    tkoiketos.grid(column=4, row=0, columnspan=2, sticky=W)
    tkoiketos['values'] = filloik_etos(vasi)
    tkoiketos.current(0)
    tkoiketos.bind('<<ComboboxSelected>>', setlist)
    
    l=Listbox(kentrikoframe,width=10, height=10)
    l.grid(column=1, row=1, rowspan=6, sticky=(N,S,W,E))
    s=ttk.Scrollbar(kentrikoframe, orient=VERTICAL, command=l.yview)
    s.grid(column=2, row=1, rowspan=6, sticky=(N,S))
    l['yscrollcommand'] = s.set

    txt=StringVar()
    lab=ttk.Label(kentrikoframe, textvariable=txt)
    lab.grid(column=1, columnspan=2,  row=7)
    for row in recs:
        l.insert(END,  row[0])
    txt.set('Πληροφορίες')
    l.bind('<Double-1>', setme )
    l.bind('<Return>', setme)
    l.bind("<<ListboxSelect>>", setme)
    syndesi_tt.close()    
    
    #Δημιουργία των πεδίων
    ttk.Label(kentrikoframe,  text='Α/Α:').grid(column=3, row=1, sticky=W)
    tkaa = ttk.Entry(kentrikoframe, width=9, state=DISABLED, textvariable=aa)
    tkaa.grid(column = 4, row = 1, sticky =(W, E))
    
    ttk.Label(kentrikoframe,  text='ΑΦΜ:').grid(column=3, row=2, sticky=W)
    tkafm = ttk.Entry(kentrikoframe, width=9, textvariable=afm) #,textvariable=afm
    tkafm.grid(column = 4, row = 2, sticky =(W, E))

    nm=ttk.Label(kentrikoframe, textvariable=epixirisi, font=('bold'))
    nm.grid(column=3, row =3, columnspan=4, sticky=(W,E))
    s=ttk.Separator(kentrikoframe)
    s.grid(row=8, column=1, columnspan=5, sticky=(W,E))
    
    ttk.Label(kentrikoframe,  text='Αριθμός Απόδειξης:').grid(column=3, row=4, sticky=W)
    tkgar_apod = ttk.Entry(kentrikoframe, width=10,  textvariable= ar_apod ) #,textvariable=afm
    tkgar_apod.grid(column = 4, row = 4, sticky =(W, E))

    ttk.Label(kentrikoframe,   text='Ημερομηνία:').grid(column=3, row=5, sticky=W)
    tkhmeromhnia = ttk.Entry(kentrikoframe, width= 10,  textvariable = hmerominia) #,textvariable=afm
    tkhmeromhnia.grid(column = 4, row = 5, sticky =(W, E))
    
    ttk.Label(kentrikoframe,  text='Τύπος Αγοράς: ').grid(column=3, row=6, sticky=W)
    tktyposagoras = ttk.Combobox(kentrikoframe,  width = 20, textvariable = typosagoras)
    tktyposagoras.grid(column = 4, row = 6, columnspan = 2, sticky =W)
    tktyposagoras['values']= fillcombo(vasi)
    ttk.Label(kentrikoframe,  text='Ποσό: ').grid(column=3, row=7, sticky=W)
    tkposo = ttk.Entry(kentrikoframe, width= 10,  textvariable = gposo) #,textvariable=afm
    tkposo.grid(column = 4, row = 7, sticky =(W, E))

    #Δημιουργία κουμπιών
    ttk.Button(kentrikoframe, text= 'Διαγραφή', command = lambda:del_record(vasi, l.curselection())).grid(column =1, row =9, sticky=W)
    ttk.Button(kentrikoframe, text='Ενημέρωση', command=updateme).grid(column=3, row=9, sticky=(E,W))
    
    #Προσωρινή λύση για windows. ;)
    if getplatform() == 'windows':
        mystate = 'DISABLED'
    else:
        mystate = 'NORMAL'
    
    klisimo=ttk.Button(kentrikoframe, text= 'Κλείσιμο', state=mystate, command=win.destroy)
    klisimo.grid(column =4, row =9, sticky=(E,W))
    klisimo.bind('<Return>', exitme)
    
    for child in kentrikoframe.winfo_children():
        child.grid_configure(padx=5, pady=5)
    setlist()
    win.update_idletasks()
    screen_width=win.winfo_screenwidth()
    screen_hight=win.winfo_screenheight()
    w = win.winfo_width()
    h = win.winfo_height()
    win.geometry("%dx%d%+d%+d" % (w, h, (screen_width-w)/2, (screen_hight-h)/2+60))
    
    win.grab_set()
    win.focus_set()
    l.selection_set(0)
    setme(None)
    win.wait_window()

def showlicense():
    from tkinter.scrolledtext import ScrolledText
    root04 =Toplevel()
    root04.title('Copyright...')
    root04.resizable(0, 0)
    try:
        root04.wm_attributes('-toolwindow', 1)
    except:
        pass

    def keyenter(event):
        root04.destroy()
       
    fh = open(copyrightfile, 'r')
    msg = fh.read()
    fh.close()
    
    kentrikoframe = ttk.Frame(root04)
    kentrikoframe.grid(column=0, row=0, sticky=(N, W, S, E))
    kentrikoframe.columnconfigure(0, weight=1)
    kentrikoframe.rowconfigure(0, weight =1)
    
    t=  ScrolledText(kentrikoframe, height=38, width=75, bg='#d9d9d9', relief=FLAT)
    t.grid(column=0, row=0, sticky=(N,S,E,W))
    t.insert(1.0, msg)
    t.insert(END, '\n')
    t.configure(state=DISABLED)

    
    koumpi=ttk.Button(kentrikoframe, text='Κλείσιμο', command=root04.destroy)
    koumpi.grid(column=0, row=1, sticky=E)
    koumpi.bind('<Return>', keyenter)
    
    for child in kentrikoframe.winfo_children():
        child.grid_configure(padx=1, pady=1)
    
    root04.update_idletasks()
    screen_width=root04.winfo_screenwidth()
    screen_hight=root04.winfo_screenheight()
    w = root04.winfo_width()
    h = root04.winfo_height()
    root04.geometry("%dx%d%+d%+d" % (w, h, (screen_width-w)/2, (screen_hight-h)/2))
    root04.grab_set()
    root04.focus_set()
    koumpi.focus()
    root04.wait_window()

def ask_me(q):
    return messagebox.askyesno('Αποδείξεις', q)   
        
if __name__== '__main__':
    showlicense()
