#!/usr/bin/env python3
#-*-coding:utf-8-*-

#==================================================================================
#  Copyright:
#            
#      Copyright (C) 2010 Konstas Marmatakis <marmako@gmail.com>
#
#   License:
#  
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License version 2 as
#      published by the Free Software Foundation.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this package; if not, write to the Free Software
#      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#================================================================================== 

'''
Created on 22 Φεβ 2010

@author: kostas
'''

import sqlite3, locale, csv
from tkinter import Tk, ttk, IntVar, messagebox
from tkinter.constants import RAISED, E, N, S, W
locale.setlocale(locale.LC_ALL, '')

from libs.lib import convert_ddate

def printit(databname):
    
    grammes=54 #Αρχικοποιήσεις
    selida= 0
    eggrafh=1
    synolo =0
    syndesi = sqlite3.connect(databname)
    curr = syndesi.cursor()
    query = "SELECT apodixis.aa, apodixis.afm, epixirisis.eponimia, apodixis.arithmos_apod, eidos_agoras.perigrafi,\
     apodixis.ddate, apodixis.poso FROM apodixis INNER JOIN eidos_agoras ON eidos_agoras.eidos_id\
      = apodixis.typos_agoras INNER JOIN epixirisis ON epixirisis.afm = apodixis.afm"
    #Πρώτο Πέρασμα για να βρούμε τον αριθμό των εγγραφών και σελίδων 
    numera =0
    for row in curr.execute(query):
        numera += 1
    selides = numera/grammes
    if numera%grammes>0:
        selides +=1
    selides = int(selides)
    print_epikefalida('ΚΑΤΑΣΤΑΣΗ ΑΠΟΔΕΙΞΕΩΝ ΟΙΚΟΝΟΜΙΚΟΥ ΕΤΟΥΣ 2010')
    print_kefalidasel(True)
    print('-'*85)

            
    for row in curr.execute(query):
        if eggrafh%grammes !=0 or numera- eggrafh !=0:
            print('|', end='') #1 ok
            print('{0:5d}'.format(row[0]), end ='') #5 ok
            print('|', end='') #1 ok
            print(row[1], end ='')#9 ok
            print('|', end='') #1 ok
            print('{0:20}'.format(row[2][:20]), end ='') #23
            print('|', end='') #1
            print('{0:8}'.format(row[3].rjust(8)), end ='') #8
            print('|', end='') #1
            print('{0:14}'.format(row[4][:14]), end ='') #14
            print('|', end='') #1
            print('{0}'.format(convert_ddate(row[5])).center(12), end ='') #10
            print('|', end='') #1
            print('{0}|'.format(locale.currency(row[6]).rjust(10), end = '')) #10
            #print(row[5], end = '')
            
            eggrafh +=1
            synolo +=row[6]
            if eggrafh%grammes==0 or eggrafh> numera:
                selida+=1
                if selida < selides:
                    print_yposeledo(int(selida), int(selides), locale.currency(synolo,grouping = True), False)
                    
                    print("\f")
                    print_kefalidasel(True)
                    print_kefalidasel(False, locale.currency(synolo,grouping = True))
                    
                else:
                    diafora = (grammes*selides-eggrafh)-5
                    print_yposeledo(int(selida), int(selides), locale.currency(synolo,grouping = True), True, diafora)
                    

    syndesi.close()

def print_eggrafes():
    pass   

def print_epikefalida(titlos):
    print('{0}'.format(titlos.center(77)))
    
def print_kefalidasel(proti = True, synoloapomet='', diafora=0):
    if proti==True:
        print('-'*85)
        print('|', end='') #1
        print(' Α/Α ', end='') #5
        print('|', end='') #1
        print('   ΑΦΜ   ', end ='') #9
        print('|', end='') #1
        print(' '*5, end = '') #6
        print(' ΠΕΡΙΓΡΑΦΗ', end ='') #11
        print(' '*5, end = '') #7
        print('|', end='') #1
        print('ΑΡ. ΑΠ. ', end ='') #11
        print('|', end='') #1
        print(' ΕΙΔΟΣ ΑΓΟΡΑΣ ', end ='') #14
        print('|', end='') #1
        print(' ΗΜΕΡΟΜΗΝΙΑ ', end ='') #12
        print('|', end='') #1
        print('   ΠΟΣΟ   ',  end ='') #10
        print('|') #1
        #print('-'*80)
    else:
        print('-'*85)
        print('|', end='') #1
        print('ΣΥΝΟΛΟ ΑΠΟ ΜΕΤΑΦΟΡΑ', end='') #18
        print(' '*54, end ='') #50
        print('|', end='') #1
        print('{0}'.format(synoloapomet).rjust(10,'#'), end ='') #9
        print('|') #1
        print('-'*85)

def print_yposeledo(selida, selides, sinolosemetafora=0, teleytaia = False, diafora=0):
    if teleytaia == False:
        print('-'*85)
        print('|', end='') #1
        print('ΣΥΝΟΛΟ ΣΕ ΜΕΤΑΦΟΡΑ', end='') #18
        print(' '*55, end ='') #50
        print('|', end='') #1
        print('{0}'.format(sinolosemetafora).rjust(10,'#'), end ='') #9
        print('|') #1
        print('-'*85)
        print(' '*67, end='') #60
        print('ΣΕΛΙΔΑ {0:2d} ΑΠΟ {1:2d}'.format(selida, selides)) #16
    elif teleytaia ==True:
        print('-'*85)
        print('|', end='') #1
        print('ΓΕΝΙΚΟ ΣΥΝΟΛΟ  ', end='') #18
        print(' '*58, end ='') #50
        print('|', end='') #1
        print('{0}'.format(sinolosemetafora).rjust(10,'#'), end ='') #9
        print('|') #1
        print('-'*85)
        print("\n"*diafora)
        print(' '*67, end='') #60
        print('ΣΕΛΙΔΑ {0:2d} ΑΠΟ {1:2d}'.format(selida, selides))

def prn_html(databname, erotima ='', v=()):
    '''Εκτυπώνει τις εγγραφές του αρχείου αποδεί=ξεων μορφοποιημένες
    σε html. 
    '''
    import tempfile
    synolo=0
    syndesi = sqlite3.connect(databname)
    curr = syndesi.cursor()
    if len(v) > 1:
        query0 = "SELECT COUNT(afm) as metrisi FROM apodixis WHERE oik_etos= ? AND typos_agoras IN ({0})".format(','.join('?'*(len(v)-1)))
    elif len(v) == 1:
        query0 = "SELECT COUNT(afm) as metrisi FROM apodixis WHERE oik_etos= ?"
    
    htmlfile = tempfile.gettempdir() + '/apodixis.html'
# Άνοιγμα υποχρεωτικά με encoding = 'utf-8' γιατί τα windows κάνουν τα δικά τους.
    fp= open(htmlfile, encoding='utf-8', mode='w')
    kef='''\
    <?xml version="1.0" encoding="UTF-8"?>
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
        <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
        <head>
    '''
    met='''<meta name=\"author\" content=\"Μαρματάκης Κώνστας\"/>
            <meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\"/>
            <meta http-equiv=\"content-type\" content=\"application/xhtml+xml; charset=UTF-8\"/>
            <meta http-equiv=\"content-style-type\" content=\"text/css\"/>
            <meta http-equiv=\"expires\" content=\"0\"/>
            </head>'''
    kefpin="""\
        <th align='center' valign='middle'>Α/Α</th>
        <th align='center' valign='middle'>ΑΦΜ</th>
        <th align='center' valign='middle'>ΠΕΡΙΓΡΑΦΗ</th>
        <th align='center' valign='middle'>ΑΡ. ΑΠΟΔ.</th>
        <th align='center' valign='middle'>ΕΙΔΟΣ ΑΓΟΡΑΣ</th>
        <th align='center' valign='middle'>ΗΜΕΡΟΜΗΝΙΑ</th>
        <th align='center' valign='middle'>ΠΟΣΟ</th>
    """
    fp.write(kef)
    fp.write('<title>ΚΑΤΑΣΤΑΣΗ ΑΠΟΔΕΙΞΕΩΝ</title>')
    fp.write(met) 
    fp.write('<body>')
    fp.write('<h2 align=center>Κατάσταση Αποδείξεων</h2>')
    fp.write('<table style=\"margin-left:auto; margin-right:auto; font-family: courier, \'courier new\', monospace;\" border=1 rules=\"all\" frame=\"box\">')
    fp.write('<thead>')
    fp.write(kefpin)
    fp.write('</thead>')
   
    
    curr. execute(query0, v)
    rows=curr.fetchall()
    for row in rows:
        recs= row[0]
    messagebox.showinfo('','Σύνολο εγγραφών: {0}.'.format(recs))
    
    if len(erotima) == 0:
        query = "SELECT apodixis.aa, apodixis.afm, epixirisis.eponimia, apodixis.arithmos_apod, eidos_agoras.perigrafi,\
         apodixis.ddate, apodixis.poso FROM apodixis INNER JOIN eidos_agoras ON eidos_agoras.eidos_id\
          = apodixis.typos_agoras INNER JOIN epixirisis ON epixirisis.afm = apodixis.afm ORDER BY apodixis.aa"
        curr.execute(query)
    else:
        curr.execute(erotima, v)
    
    
    while True:
        rows = curr.fetchmany()
        if not rows:
            break
        for row in rows:
            fp.write('<tr><td align=\"right\">')
            fp.write('{0:5d}'.format(row[0])) #5 ok
            fp.write('</td><td>') #1 ok
            fp.write(row[1])#9 ok
            fp.write('</td><td>') #1 ok
            fp.write('{0:20}'.format(row[2][:20])) #23
            fp.write('</td><td align=\"right\">') #1
            fp.write('{0:8}'.format(row[3][:8])) #8
            fp.write('</td><td>') #1
            fp.write('{0:14}'.format(row[4][:8]).ljust(8)) #14
            fp.write('</td><td>') #1
            fp.write('{0}'.format(convert_ddate(row[5])).center(12)) #10
            fp.write('</td><td align=\"right\">') #1
            fp.write('{0}'.format(locale.currency(row[6], grouping=True).rjust(10))) #10
            fp.write('</td></tr>\n')
            synolo +=row[6]
#    fp.write('<tfoot>')
    fp.write('<tr><td colspan="6"><strong>Γενικό Σύνολο:</strong></td><td><strong>{0}</strong></td></tr>'.format(locale.currency(synolo, grouping=True).rjust(12,'#')))
#    fp.write('</tfoot>')
    fp.write('</table>')
    fp.write('</html>')
    fp.close()
    syndesi.close()
    return htmlfile

###############################################################################

def pbprn():
    root =Tk()
    root.title('Πρόοδος Δημιουργίας Αρχείου')
    rec=0 #@UnusedVariable
    kentrikoframe = ttk.Frame(root, relief=RAISED)
    kentrikoframe.grid(column=0, row=0, sticky=(N, W, S, E))
    kentrikoframe.columnconfigure(0, weight=1)
    kentrikoframe.rowconfigure(0, weight =1)
    rec=IntVar()
    rec.set(0)
    def changerec():
        if rec.get()<=100:
            
            rec.set(rec.get()+1)
            root.after(10,changerec)
    pb=ttk.Progressbar(kentrikoframe, length=400,  variable=rec, maximum =100)
    
    pb.grid(column=1, row = 1, sticky=(W,E))
    
    for child in kentrikoframe.winfo_children():
            child.grid_configure(padx=5, pady=5)
    changerec()
    root.mainloop()    
###############################################################################

def expcsv(databasename):
    '''
       Εξάγει τα δεδομένα σε csv αρχείο.
    '''
        
    locale.getlocale()
    syndesi = sqlite3.connect(databasename)
    curr = syndesi.cursor()
    query = "SELECT apodixis.aa, apodixis.afm, epixirisis.eponimia, apodixis.arithmos_apod, eidos_agoras.perigrafi,\
     apodixis.ddate, apodixis.poso FROM apodixis INNER JOIN eidos_agoras ON eidos_agoras.eidos_id\
      = apodixis.typos_agoras INNER JOIN epixirisis ON epixirisis.afm = apodixis.afm"
    
    ftowrite = csv.writer(open('apodixis.csv', encoding='utf-8', mode='w'), delimiter=';',quoting=csv.QUOTE_ALL)
    
    curr.execute(query)
    while True:
        rows = curr.fetchmany()
        if not rows:
            break
        for row in rows:
            ftowrite.writerow([row[0]]+[row[1]]+[row[2]]+[row[3]]+[row[4]]+[row[5]]+[(str(row[6])).replace('.', ',')])
    syndesi.commit()
    syndesi.close()

if __name__=='__main__':
   
    expcsv('../data/apodixis.db')