#!/usr/bin/env python3
#-*- coding: utf-8 -*-

#==================================================================================
#  Copyright:
#            
#      Copyright (C) 2010 Konstas Marmatakis <marmako@gmail.com>
#
#   License:
#  
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License version 2 as
#      published by the Free Software Foundation.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this package; if not, write to the Free Software
#      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#================================================================================== 
'''
Created on 20 Φεβ 2010

@author: kostas
'''
import sqlite3
import sys
import os
from tkinter.messagebox import showerror

def create_dir():
        
        if sys.platform.startswith('win') or sys.platform.endswith('NT'):
            the_path = os.path.normpath(os.environ['APPDATA'] + os.sep + '.apodixis' \
                                        + os.sep + 'data')
        else:
            the_path = os.path.normpath(os.path.expanduser('~') + os.sep + '.apodixis/data')

        if not os.path.exists(the_path):
            
            try:
                os.mkdir(the_path)
            except:
                os.makedirs(the_path)
        return the_path

def wcreate_vasi(databaseonoma, initial=1, scr='data/restoreme.sql'):
    """
    Creates a database from sql script.    
    """
    from guinterface.tkuiapodixis import ask_me
    syndesi = sqlite3.connect(databaseonoma)
    
    syndesi.executescript(open(scr, encoding='utf8').read())
    syndesi.commit()
    
    if initial == 1:
        if ask_me('Θέλετε να εισαχθούν τύποι αγοράς;') == True:
            try:
                file = open('data/eidos_agoras.txt', 'r', encoding='utf-8')
                rows = [line.rstrip().split(';') for line in file]
                cur = syndesi.cursor()
                for row in rows:
                    cur.execute('INSERT INTO eidos_agoras VALUES( ?, ?)', row)
                syndesi.commit()
                cur.close()
                file.close()
                os.unlink('data/eidos_agoras.txt')
            except FileNotFoundError:
                showerror('Σφάλμα', 'Δεν υπάρχει το αρχείο {0}'.format('eidos_agoras.txt'))
            finally:
                if file:
                    file.close()
                if cur:
                    cur.close()
#                 if syndesi:
#                     syndesi.close()
                
                
        if ask_me('Θέλετε να εισαχθούν κάποιες επιχειρήσεις των Χανίων;\n(δείγμα με αληθινά στοιχεία)') == True:
            try:
                file = open('data/epixirisis.txt', 'r', encoding='utf-8')
                rows = [line.rstrip().split(';') for line in file]
                cur = syndesi.cursor()
                for row in rows:
                    cur.execute('INSERT INTO epixirisis VALUES( ?, ?, ?, ?, ?, ?)', row)
                syndesi.commit()
            
                
            except FileNotFoundError:
                showerror('Σφάλμα', 'Δεν υπάρχει το αρχείο {0}'.format('epixirisis.txt'))
            finally:
                if file:
                    file.close()
                    try:
                        os.unlink('data/epixirisis.txt')
                    except  OSError:
                        pass
                if cur:
                    cur.close()
#                 if syndesi:
#                     syndesi.close()
        syndesi.close()
   

def create_samples(databaseonoma):
    syndesi = sqlite3.connect(databaseonoma)
    cur = syndesi.cursor()
    cur1 = syndesi.cursor()
    q1 = 'SELECT * FROM eidos_agoras'
    q2 = 'SELECT * FROM epixirisis'
    
    fh1 = open('data/eidos_agoras.txt', 'w', encoding='utf-8')
    cur.execute(q1)
    rows = cur.fetchall()
    for row in rows:
        fh1.write(str(row[0]) +';'+ row[1])
        fh1.write('\n')
    fh1.close()

    
    cur1.execute(q2)
    fh2 = open('data/epixirisis.txt', 'w', encoding='utf-8')
    rows = cur1.fetchall()
    
    for row in rows:
        
        fh2.write(row[0]+';'+ row[1]+';'+ row[2]+';'+ row[3]+';'+ row[4]+';'+str(row[5]) or None)
        fh2.write('\n')
    fh2.close()
    cur.close()
    cur1.close()
    syndesi.close()


# def wcreate_vasi(databaseonoma):
#     '''Δημιουργεί τη βάση δεδομένων της εφαρμογής
#     αν αυτή δεν υπάρχει.
#     Ορίσματα: Η διαδρομή και το όνομα της βάσης δεδομένων'''
#     
#     if os.path.exists(os.path.dirname(databaseonoma)):
#         syndesi = sqlite3.connect(databaseonoma)
#     else:
#         os.mkdir(os.path.dirname(databaseonoma))
#         syndesi = sqlite3.connect(databaseonoma)
#     
#     curr = syndesi.cursor()
#     print('Δημιουργία βάσης και πινάκων... ')
#     scrpt = open('data/restoreme.sql').read()
#     curr.executescript(scrpt)
#    
#     print('Η βάση "{0}" δημιουργήθηκε'.format(databaseonoma))
#     syndesi.commit()
#     syndesi.close()  

def fillafm(databasename):
    typoi =[]
    syndesi_t = sqlite3.connect(databasename)
    curr = syndesi_t.cursor()
    curr.execute("SELECT afm FROM epixirisis ORDER BY afm")
    for row in curr:
        typoi.append(row[0])
    return typoi

def fillcombo(databasename):
    typoi =[]
    syndesi_t = sqlite3.connect(databasename)
    curr = syndesi_t.cursor()
    curr.execute("SELECT perigrafi FROM eidos_agoras ORDER BY eidos_id")
    
    for row in curr:
        typoi.append(row[0])
    syndesi_t.commit()
    syndesi_t.close()
    return typoi

def typos_agoras(dbasename):
    typoi=[]
    eidosnum=[]
    syndesi_t = sqlite3.connect(dbasename)
    curr = syndesi_t.cursor()
    curr.execute("SELECT * FROM eidos_agoras ORDER BY eidos_id")
    for row in curr:
        typoi.append(row[1])
        eidosnum.append(row[0])
    #typoi =['ΤΡΟΦΙΜΑ', 'ΕΝΔΥΣΗ - ΥΠΟΔΗΣΗ', 'ΚΑΥΣΙΜΑ', 'ΕΣΤΙΑΤΟΡΙΑ - ΤΑΒΕΡΝΕΣ', 'ΠΑΡΚΙΝΚ', 'ΚΟΜΜΩΤΗΡΙΑ', 'ΑΙΣΘΗΤΙΚΟΣ', 'ΑΛΛΕΣ ΥΠΗΡΕΣΙΕΣ']
    for i in range(len(typoi)):
        print("{0} ==> {1}".format(eidosnum[i], typoi[i]))
    typosi =input("Δώστε τον αντίστοιχο αριθμό για τον τύπο της απόδειξης: ")
    try:
        return eidosnum[int(typosi)-1]
    except:
        print("Ο αριθμός είναι λάθος ή καθόλου αριθμός")
        return None
def agora_int(dbasename, tipsaxno):
    syndesi_t = sqlite3.connect(dbasename)
    curr = syndesi_t.cursor()
    curr.execute("SELECT eidos_id FROM eidos_agoras WHERE perigrafi = '{0}' ORDER BY eidos_id".format(str(tipsaxno)))
    
    return int(curr.fetchone()[0])
    syndesi_t.close()
    
def agora(dbasename, tipsaxno):
    syndesi_t = sqlite3.connect(dbasename)
    curr = syndesi_t.cursor()
    curr.execute("SELECT perigrafi FROM eidos_agoras WHERE eidos_id = {0} ORDER BY eidos_id".format(int(tipsaxno)))
    
    return curr.fetchone()[0]
    syndesi_t.close()
    
def check_afm(toafm):
    import urllib.request
    import urllib.error
    import re
    if is_number(toafm):
        if len(toafm.strip())== 9:
            try:
                theurl='http://www.gsis.gr/gsis/servlet/gsisNew/checkAFM?afm={0}'.format(toafm)
                handletheurl =urllib.request.urlopen(theurl).read()
                tokeimeno =handletheurl.decode('iso-8859-7')
                if re.match('δέν είναι έγκυρος', tokeimeno):
                    return False
                return True
            except urllib.error.HTTPError:
                print('Το ΑΦΜ: {0} είναι έγκυρο ως προς το μήκος και τα ψηφία.\nΔεν ελέχθηκε μέσω Internet.'.format(toafm))
                return True
        else:
            return False
    else:
        return False    


def is_number(s):
    try:
        float(s)
        return True
    except ValueError:
        return False

def check_if_exist(toafm, databasename):
    syndesi = sqlite3.connect(databasename)
    curr = syndesi.cursor()
    curr.execute("select * from epixirisis where afm = ?", (toafm,))
    for row in curr:
        if row[0]== toafm:
            syndesi.close()
            return True
    syndesi.close()
    return False
    

def check_sum(databasename):
    import locale
    locale.setlocale(locale.LC_ALL, '')
    
    try:
        syndesi = sqlite3.connect(databasename)
        curr = syndesi.cursor()
        curr.execute('select round(sum(poso),2) as sinolo from apodixis')
        for row in curr:
            return locale.currency(row[0], grouping=True)
    except:
        print('Σφάλμα')
        return 0


def conveisodohmerominias(eisodos):
    from datetime import datetime
    morfes= ["%d-%m-%Y", "%d-%m-%y", "%d/%m/%Y", "%d/%m/%y", "%d-%m-%y",  "%Y-%m-%d", "%y-%m-%d"]
    for i in range(len(morfes)):
        try:
            exodos = datetime.strptime(eisodos,morfes[i]).strftime("%Y-%m-%d")
        except ValueError:
            continue
    return exodos

def convert_ddate(eisodos):
    neaeisodos = eisodos.split('-')
    return neaeisodos[2]+'-'+neaeisodos[1]+'-'+ neaeisodos[0]

def pare_dedomena(toafm, databasename):
    dedomena=[]
    syndesi= sqlite3.connect(databasename)
    curr = syndesi.cursor()
    curr.execute("select * from epixirisis where afm = ?", (toafm,))
    for row in curr:
        for item in row:
            dedomena.append(item)
    return dedomena


def apothikeysh(databasename, *dedomena):
        syndesi = sqlite3.connect(databasename)
        curr = syndesi.cursor()
        curr.execute("INSERT INTO epixirisis (afm, doy, eponimia, dieythinsi, thlefono) VALUES (?, ?, ?, ?, ?)",(dedomena))
        syndesi.commit()
        syndesi.close()

def insert_agora(databasename, *dedomena):
    syndesi = sqlite3.connect(databasename)
    curr = syndesi.cursor()
    curr.execute("INSERT INTO eidos_agoras (perigrafi) VALUES(?)",(dedomena))
    syndesi.commit()
    syndesi.close()

def getplatform():
    if sys.platform.startswith('win'):
        return 'windows'
    elif sys.platform.startswith('darwin'):
        return 'mac'
    else:
        return 'linux'

def filloik_etos(databasename):
    oiketos=[]
    syndesi = sqlite3.connect(databasename)
    curr = syndesi.cursor()
    
    curr.execute("SELECT DISTINCT oik_etos FROM apodixis ORDER BY oik_etos DESC")
    for row in curr.fetchall():
        oiketos.append(row[0])
    
    curr.close()
    syndesi.close()
    return oiketos

if __name__ == '__main__':
    check_afm('028555248')
