#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import sqlite3
from datetime import datetime


def storedata(databasename, pinakas, *args):
    
    syndesi = sqlite3.connect(databasename)
    curr = syndesi.cursor()

    if pinakas == 'apodixis':
        try:
            d = args[0]
            print(d, type(d))
            try:
                yr = d.strftime("%Y")
            except:
                try:
                    d = datetime.strptime(d, "%Y-%m-%d")
                    print(d, type(d))
                    yr = d.strftime("%Y")
                except:
                    print ("Error")
                    
            curr.execute("SELECT MAX(aa)  + 1 from apodixis WHERE oik_etos = ?", (yr,))
            num = curr.fetchone()[0]
            
            curr.execute("insert into apodixis  (ddate, arithmos_apod, afm, doy, typos_agoras, poso, aa) values ( ?, ? , ? , ? ,? ,? , " + str(num) + ")", (args))
        except (sqlite3.IntegrityError, sqlite3.OperationalError) as err:
            print(err)            
            try:
                curr.execute("insert into apodixis  (ddate, arithmos_apod, afm, doy, typos_agoras, poso, aa) values ( ?, ? , ? , ? ,? ,? ,     1)", (args))
            except:
                tominima = ""
                return tominima
        syndesi.commit()
        curr.execute("SELECT aa, oik_etos FROM apodixis WHERE aa = (SELECT max(aa) FROM apodixis WHERE oik_etos=?)", (yr,))
        for row in curr:
            tominima = "Ο αριθμός καταχώρισης για το έτος {1} είναι: {0}. Παρακαλώ γράψτε τον πάνω στην απόδειξη.".format(row[0], row[1])
            # print (tominima)
    else:
        curr.execute("INSERT INTO epixirisis (afm, doy, eponimia, dieythinsi, thlefono) VALUES (?, ?, ?, ?, ?)", (args))
        syndesi.commit()
        syndesi.close()
    return tominima


if __name__ == '__main__':

    data = [('2012-01-01', '24', '037122361', 'A', 2, 22.01),
       ('2013-01-01', '24', '037122361', 'A', 1, 22.01),
       ('2014-01-01', '24', '037122361', 'A', 2, 23.01),
       ('2012-01-01', '25', '037122361', 'A', 2, 22.01),
       ('2012-01-01', '26', '037122361', 'A', 9, 22.01),
       ('2010-01-01', '26', '037122361', 'A', 2, 22.01),
       ('2012-01-02', '26', '037122361', 'A', 2, 20.01),
       ('2010-01-11', '26', '037122361', 'A', 6, 2.01),
       ('2012-01-09', '26', '037122361', 'A', 5, 11.91),
       ('2010-01-19', '27', '037122361', 'A', 2, 2.01),
       ('2008-01-02', '26', '037122361', 'A', 2, 20.01),
       ('2008-01-11', '26', '037122361', 'A', 6, 2.01),
       ('2008-01-09', '26', '037122361', 'A', 5, 11.91)]

    for a, b, c, d, e, f in data:
        print(storedata('../data/apodixis.db', 'apodixis', a, b, c, d, e, f))
