#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#==================================================================================
#  Copyright:
#            
#      Copyright (C) 2010 Konstas Marmatakis <marmako@gmail.com>
#
#   License:
#  
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License version 2 as
#      published by the Free Software Foundation.
#
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with this package; if not, write to the Free Software
#      Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#================================================================================== 
'''
Created on 14-03-2010
Edited: 01-06-2013

'''
from distutils.core import setup
from distutils.util import get_platform
import codecs

try:
    codecs.lookup('mbcs')
except LookupError:
    ascii = codecs.lookup('ascii')
    func = lambda name, enc=ascii: {True: enc}.get(name=='mbcs')
    codecs.register(func) 

setup(name = 'apodixis',
      version = open('data/VERSION').read().rstrip(),
      description =  'An application for collect and summarize receipts.', #'Πρόγραμμα για την Καταχώρηση Αποδείξεων',
      long_description = """
**Apodixis**
============

A small personal application for collect and summarize 
receipts for the greek taxpayers.""",
      license = 'GNU General Public License v2 (GPLv2)',
 
      author = 'Konstas Marmatakis',
      author_email = 'marmako@gmail.com',
      url = 'none',
      #package_dir = 'apodixis',
      packages = ['libs', 'guinterface'],
      data_files = [('images',['images/apodixi.gif', 'images/apodixi_logo.gif','images/apodixi_logo_new.gif', \
                    'images/apodixi_logo_128x128.gif', 'images/python-powered.gif']), 
                    ('docs', ['docs/gpl.txt', 'docs/gpl-2.0-standalone.html']),
                    ('data', ['data/VERSION', 'data/epixirisis.txt', 'data/eidos_agoras.txt', 'data/restoreme.sql'])],
                   # ('share/applications', ['data/apodixis.desktop'])],
      
      scripts=["apodixis.py", "create_lnk.py"],
      
      platforms = 'all',
      
      classifiers = [
                   'Development Status :: 4 - Beta',
                   'Environment :: X11 Applications',
                   'Intended Audience :: End Users/Desktop',
                   'License :: OSI Approved :: GNU General Public License (GPL)',
                   'Natural Language :: Greek',
                   'Programming Language :: Python :: 3.1',
                   'Topic :: Office/Business :: Financial :: Accounting',
                   'License :: OSI Approved :: GNU General Public License v2 (GPLv2)'])
